//   
//  4 (02  2004 )

// Set
// version 1.0
// (c) Demidov Vladimir, 2004

//   
//  

// www.demidovvova.narod.ru
// E-mail: demidovvova@narod.ru

#include <iostream> //      -
#include <math.h>  
#include <conio.h> //   Linux

using namespace std; //    Turbo C


typedef int Set_Type;
const int Set_Max_Size = 256;

int Set_In (Set_Type A[Set_Max_Size], int Set_Size, Set_Type x)
{
	int i;
	int n = (Set_Size < Set_Max_Size) ? Set_Size : Set_Max_Size;
	for (i=0; i<n; i++)
		if (A[i] == x) return 1+i;
	return 0;
}

int Set_Add (Set_Type A[Set_Max_Size], int Set_Size, Set_Type x)
{
	int i;
	if (Set_In(A, Set_Size, x) == 0 && Set_Size < Set_Max_Size) 
	{
		A[Set_Size] = x;
		Set_Size++;
	}
	return Set_Size;
}

int Set_Del (Set_Type A[Set_Max_Size], int Set_Size, Set_Type x)
{
	int i, k = Set_In(A, Set_Size, x);
	int n = (Set_Size < Set_Max_Size) ? Set_Size : Set_Max_Size;
	if (k > 0)
	{
		for (i = k; i < n; i++) A[i-1] = A[i];
		Set_Size = n - 1;
	}
	return Set_Size;
}

int Set_Clear (Set_Type A[Set_Max_Size], int Set_Size)
{
	return 0;
}

int Set_Copy (Set_Type C[Set_Max_Size],
			  Set_Type A[Set_Max_Size], int Set_Size)
{
	int i;
	int n = (Set_Size < Set_Max_Size) ? Set_Size : Set_Max_Size;
	for (i = 0; i < n; i++) C[i] = A[i];
	return Set_Size;
}

int Set_Objedinenie (Set_Type C[Set_Max_Size],
					 Set_Type A[Set_Max_Size], int Set_Size_A,
					 Set_Type B[Set_Max_Size], int Set_Size_B)
{
	int i;
	int s = Set_Copy (C, A, Set_Size_A);
	for (i = 0; i < Set_Size_B; i++) s = Set_Add (C, s, B[i]);
	return s;
}

int Set_Peresechenie (Set_Type C[Set_Max_Size],
					  Set_Type A[Set_Max_Size], int Set_Size_A,
					  Set_Type B[Set_Max_Size], int Set_Size_B)
{
	int i;
	int s = 0;
	for (i = 0; i < Set_Size_A; i++) 
		if (Set_In(B, Set_Size_B, A[i])) s = Set_Add (C, s, A[i]);
	return s;
}

int Set_Iskluchenie (Set_Type C[Set_Max_Size],
					 Set_Type A[Set_Max_Size], int Set_Size_A,
					 Set_Type B[Set_Max_Size], int Set_Size_B)
{
	int i;
	int s = 0;
	for (i = 0; i < Set_Size_A; i++) 
		if (Set_In(B, Set_Size_B, A[i]) == 0) s = Set_Add (C, s, A[i]);
	return s;
}

void Set_Print (Set_Type A[Set_Max_Size], int Set_Size)
{
	int i;
	int n = ( (Set_Size < Set_Max_Size) ? Set_Size : Set_Max_Size ) - 1;
	for (i=0; i<n; i++)
	{
		cout << A[i] << ", ";
	}
	if (n>=0) cout << A[n];
	cout << endl;
}

int Menu (char *str)
{
	int n = 0;
	cout << str << ">>";
	cin >> n;
	return n;
}

int main (void)
{
	cout << "Set Static\nversion 1.0\n";
	Set_Type A[Set_Max_Size];
	int Set_Size_A = 0;
	Set_Type B[Set_Max_Size];
	int Set_Size_B = 0;
	Set_Type C[Set_Max_Size];
	int Set_Size_C = 0;
	Set_Type T[Set_Max_Size];
	int Set_Size_T = 0;

	Set_Type x;
	for (;;)
	switch ( Menu ("1. Add A\n2. Del A\n3. Clear A\n4. C = A + B\n5. C = A * B\n6. C = A \\ B\n7. A <-> B\n8. A <-> C\n9. Print\n0. Exit\n") )
	{
	case 1:
		cout << "x : "; cin >> x;
		Set_Size_A = Set_Add (A, Set_Size_A, x);
		Set_Print(A, Set_Size_A);
		break;
	case 2:
		cout << "x : "; cin >> x;
		Set_Size_A = Set_Del (A, Set_Size_A, x);
		Set_Print(A, Set_Size_A);
		break;
	case 3:
		Set_Size_A = Set_Clear (A, Set_Size_A);
		break;
	case 4:
		Set_Size_C = Set_Objedinenie (C, A, Set_Size_A, B, Set_Size_B);
		Set_Print(C, Set_Size_C);
		break;
	case 5:
		Set_Size_C = Set_Peresechenie (C, A, Set_Size_A, B, Set_Size_B);
		Set_Print(C, Set_Size_C);
		break;
	case 6:
		Set_Size_C = Set_Iskluchenie (C, A, Set_Size_A, B, Set_Size_B);
		Set_Print(C, Set_Size_C);
		break;
	case 7:
		Set_Size_T = Set_Copy (T, A, Set_Size_A);
		Set_Size_A = Set_Copy (A, B, Set_Size_B);
		Set_Size_B = Set_Copy (B, T, Set_Size_T);
		break;
	case 8:
		Set_Size_T = Set_Copy (T, A, Set_Size_A);
		Set_Size_A = Set_Copy (A, C, Set_Size_C);
		Set_Size_C = Set_Copy (C, T, Set_Size_T);
		break;
	case 9:
		cout << "Set A: ";
		Set_Print(A, Set_Size_A);
		cout << "Set B: ";
		Set_Print(B, Set_Size_B);
		cout << "Set C: ";
		Set_Print(C, Set_Size_C);
		break;
	default :
        return 0;
	}
}